# © 2019 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import _, models
from odoo.exceptions import UserError


class FinancialDeal(models.Model):
    _inherit = "financial.deal"

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Inherit parent
    # ------------------------------------------------------
    def action_stage_validated(self):
        res = super().action_stage_validated()

        for contract in self.coop_contract_ids:
            if not contract.company_id.contract_sequence_id:
                raise UserError(
                    _(
                        f"Aucune séquence configurée pour les contrats de "
                        f"la société {contract.company_id.name}"
                    )
                )
            if not contract.number:
                contract.number = contract.company_id.contract_sequence_id.next_by_id()
        return res

    # ------------------------------------------------------
    # CRUD (Override ORM)
    # ------------------------------------------------------
