# Copyright 2023- Le Filament (https://le-filament.com)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html)

from odoo import api, fields, models


class ResCompany(models.Model):
    _inherit = "res.company"

    contract_sequence_id = fields.Many2one("ir.sequence")

    # ------------------------------------------------------
    # Fields declaration
    # ------------------------------------------------------

    # ------------------------------------------------------
    # SQL Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Default methods
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Onchange / Constraints
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD methods (ORM overrides)
    # ------------------------------------------------------
    @api.model
    def create(self, values):
        # Crée une séquence dédiée à la société
        res = super().create(values)

        res.contract_sequence_id = self.env["ir.sequence"].create(
            {
                "name": f"Contrats - {res.name}",
                "company_id": res.id,
                "number_next": 1,
                "number_increment": 1,
                "use_date_range": True,
                "prefix": "C%(year)s%(month)s",
                "padding": 4,
                "implementation": "no_gap",
                "code": f"financial.contract.company_{res.id}",
            }
        )
        return res

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Business methods
    # ------------------------------------------------------
